/**
 */
package LinkingModel;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see LinkingModel.LinkingModelFactory
 * @model kind="package"
 * @generated
 */
public interface LinkingModelPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "LinkingModel";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "lm";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	LinkingModelPackage eINSTANCE = LinkingModel.impl.LinkingModelPackageImpl.init();

	/**
	 * The meta object id for the '{@link LinkingModel.impl.LinkImpl <em>Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see LinkingModel.impl.LinkImpl
	 * @see LinkingModel.impl.LinkingModelPackageImpl#getLink()
	 * @generated
	 */
	int LINK = 0;

	/**
	 * The feature id for the '<em><b>Link To File</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__LINK_TO_FILE = 0;

	/**
	 * The feature id for the '<em><b>Link To AML</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__LINK_TO_AML = 1;

	/**
	 * The feature id for the '<em><b>Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__VERSION = 2;

	/**
	 * The feature id for the '<em><b>Change Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__CHANGE_DATE = 3;

	/**
	 * The feature id for the '<em><b>Edited By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__EDITED_BY = 4;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__NAME = 5;

	/**
	 * The feature id for the '<em><b>Children</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK__CHILDREN = 6;

	/**
	 * The number of structural features of the '<em>Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_FEATURE_COUNT = 7;

	/**
	 * The meta object id for the '{@link LinkingModel.impl.LinkingGroupImpl <em>Linking Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see LinkingModel.impl.LinkingGroupImpl
	 * @see LinkingModel.impl.LinkingModelPackageImpl#getLinkingGroup()
	 * @generated
	 */
	int LINKING_GROUP = 1;

	/**
	 * The feature id for the '<em><b>Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINKING_GROUP__LINKS = 0;

	/**
	 * The number of structural features of the '<em>Linking Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINKING_GROUP_FEATURE_COUNT = 1;


	/**
	 * The meta object id for the '{@link LinkingModel.impl.RealizedByImpl <em>Realized By</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see LinkingModel.impl.RealizedByImpl
	 * @see LinkingModel.impl.LinkingModelPackageImpl#getRealizedBy()
	 * @generated
	 */
	int REALIZED_BY = 2;

	/**
	 * The feature id for the '<em><b>Link To File</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZED_BY__LINK_TO_FILE = LINK__LINK_TO_FILE;

	/**
	 * The feature id for the '<em><b>Link To AML</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZED_BY__LINK_TO_AML = LINK__LINK_TO_AML;

	/**
	 * The feature id for the '<em><b>Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZED_BY__VERSION = LINK__VERSION;

	/**
	 * The feature id for the '<em><b>Change Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZED_BY__CHANGE_DATE = LINK__CHANGE_DATE;

	/**
	 * The feature id for the '<em><b>Edited By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZED_BY__EDITED_BY = LINK__EDITED_BY;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZED_BY__NAME = LINK__NAME;

	/**
	 * The feature id for the '<em><b>Children</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZED_BY__CHILDREN = LINK__CHILDREN;

	/**
	 * The number of structural features of the '<em>Realized By</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REALIZED_BY_FEATURE_COUNT = LINK_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link LinkingModel.impl.DependsOnImpl <em>Depends On</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see LinkingModel.impl.DependsOnImpl
	 * @see LinkingModel.impl.LinkingModelPackageImpl#getDependsOn()
	 * @generated
	 */
	int DEPENDS_ON = 3;

	/**
	 * The feature id for the '<em><b>Link To File</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDS_ON__LINK_TO_FILE = LINK__LINK_TO_FILE;

	/**
	 * The feature id for the '<em><b>Link To AML</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDS_ON__LINK_TO_AML = LINK__LINK_TO_AML;

	/**
	 * The feature id for the '<em><b>Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDS_ON__VERSION = LINK__VERSION;

	/**
	 * The feature id for the '<em><b>Change Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDS_ON__CHANGE_DATE = LINK__CHANGE_DATE;

	/**
	 * The feature id for the '<em><b>Edited By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDS_ON__EDITED_BY = LINK__EDITED_BY;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDS_ON__NAME = LINK__NAME;

	/**
	 * The feature id for the '<em><b>Children</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDS_ON__CHILDREN = LINK__CHILDREN;

	/**
	 * The number of structural features of the '<em>Depends On</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPENDS_ON_FEATURE_COUNT = LINK_FEATURE_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link LinkingModel.Link <em>Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Link</em>'.
	 * @see LinkingModel.Link
	 * @generated
	 */
	EClass getLink();

	/**
	 * Returns the meta object for the reference '{@link LinkingModel.Link#getLinkToFile <em>Link To File</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Link To File</em>'.
	 * @see LinkingModel.Link#getLinkToFile()
	 * @see #getLink()
	 * @generated
	 */
	EReference getLink_LinkToFile();

	/**
	 * Returns the meta object for the reference '{@link LinkingModel.Link#getLinkToAML <em>Link To AML</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Link To AML</em>'.
	 * @see LinkingModel.Link#getLinkToAML()
	 * @see #getLink()
	 * @generated
	 */
	EReference getLink_LinkToAML();

	/**
	 * Returns the meta object for the attribute '{@link LinkingModel.Link#getVersion <em>Version</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Version</em>'.
	 * @see LinkingModel.Link#getVersion()
	 * @see #getLink()
	 * @generated
	 */
	EAttribute getLink_Version();

	/**
	 * Returns the meta object for the attribute '{@link LinkingModel.Link#getChangeDate <em>Change Date</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Change Date</em>'.
	 * @see LinkingModel.Link#getChangeDate()
	 * @see #getLink()
	 * @generated
	 */
	EAttribute getLink_ChangeDate();

	/**
	 * Returns the meta object for the attribute '{@link LinkingModel.Link#getEditedBy <em>Edited By</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Edited By</em>'.
	 * @see LinkingModel.Link#getEditedBy()
	 * @see #getLink()
	 * @generated
	 */
	EAttribute getLink_EditedBy();

	/**
	 * Returns the meta object for the attribute '{@link LinkingModel.Link#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see LinkingModel.Link#getName()
	 * @see #getLink()
	 * @generated
	 */
	EAttribute getLink_Name();

	/**
	 * Returns the meta object for the containment reference list '{@link LinkingModel.Link#getChildren <em>Children</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Children</em>'.
	 * @see LinkingModel.Link#getChildren()
	 * @see #getLink()
	 * @generated
	 */
	EReference getLink_Children();

	/**
	 * Returns the meta object for class '{@link LinkingModel.LinkingGroup <em>Linking Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Linking Group</em>'.
	 * @see LinkingModel.LinkingGroup
	 * @generated
	 */
	EClass getLinkingGroup();

	/**
	 * Returns the meta object for the containment reference list '{@link LinkingModel.LinkingGroup#getLinks <em>Links</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Links</em>'.
	 * @see LinkingModel.LinkingGroup#getLinks()
	 * @see #getLinkingGroup()
	 * @generated
	 */
	EReference getLinkingGroup_Links();

	/**
	 * Returns the meta object for class '{@link LinkingModel.RealizedBy <em>Realized By</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Realized By</em>'.
	 * @see LinkingModel.RealizedBy
	 * @generated
	 */
	EClass getRealizedBy();

	/**
	 * Returns the meta object for class '{@link LinkingModel.DependsOn <em>Depends On</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Depends On</em>'.
	 * @see LinkingModel.DependsOn
	 * @generated
	 */
	EClass getDependsOn();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	LinkingModelFactory getLinkingModelFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link LinkingModel.impl.LinkImpl <em>Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see LinkingModel.impl.LinkImpl
		 * @see LinkingModel.impl.LinkingModelPackageImpl#getLink()
		 * @generated
		 */
		EClass LINK = eINSTANCE.getLink();

		/**
		 * The meta object literal for the '<em><b>Link To File</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK__LINK_TO_FILE = eINSTANCE.getLink_LinkToFile();

		/**
		 * The meta object literal for the '<em><b>Link To AML</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK__LINK_TO_AML = eINSTANCE.getLink_LinkToAML();

		/**
		 * The meta object literal for the '<em><b>Version</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LINK__VERSION = eINSTANCE.getLink_Version();

		/**
		 * The meta object literal for the '<em><b>Change Date</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LINK__CHANGE_DATE = eINSTANCE.getLink_ChangeDate();

		/**
		 * The meta object literal for the '<em><b>Edited By</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LINK__EDITED_BY = eINSTANCE.getLink_EditedBy();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LINK__NAME = eINSTANCE.getLink_Name();

		/**
		 * The meta object literal for the '<em><b>Children</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK__CHILDREN = eINSTANCE.getLink_Children();

		/**
		 * The meta object literal for the '{@link LinkingModel.impl.LinkingGroupImpl <em>Linking Group</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see LinkingModel.impl.LinkingGroupImpl
		 * @see LinkingModel.impl.LinkingModelPackageImpl#getLinkingGroup()
		 * @generated
		 */
		EClass LINKING_GROUP = eINSTANCE.getLinkingGroup();

		/**
		 * The meta object literal for the '<em><b>Links</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINKING_GROUP__LINKS = eINSTANCE.getLinkingGroup_Links();

		/**
		 * The meta object literal for the '{@link LinkingModel.impl.RealizedByImpl <em>Realized By</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see LinkingModel.impl.RealizedByImpl
		 * @see LinkingModel.impl.LinkingModelPackageImpl#getRealizedBy()
		 * @generated
		 */
		EClass REALIZED_BY = eINSTANCE.getRealizedBy();

		/**
		 * The meta object literal for the '{@link LinkingModel.impl.DependsOnImpl <em>Depends On</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see LinkingModel.impl.DependsOnImpl
		 * @see LinkingModel.impl.LinkingModelPackageImpl#getDependsOn()
		 * @generated
		 */
		EClass DEPENDS_ON = eINSTANCE.getDependsOn();

	}

} //LinkingModelPackage
