package Test;
import static org.junit.Assert.*;

import java.io.File;
import java.io.IOException;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceFactoryRegistryImpl;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.junit.Test;

import tools.CaexPreprocessor;
import tools.CaexSerializer;
import CAEX.util.CAEXResourceFactoryImpl;


public class RoundTripTest {

	ResourceSet resourceSet = null;
	
	@Test
	public void test() {
		
		
		ResourceFactoryRegistryImpl.INSTANCE.getExtensionToFactoryMap()
			.put("aml", new CAEXResourceFactoryImpl());
	
		ResourceFactoryRegistryImpl.INSTANCE.getExtensionToFactoryMap()
			.put("xmi", new XMIResourceFactoryImpl());
	}
	
	@org.junit.Test
	public void testRoundTrip() throws Exception{
		File xmlFile = new File("input/PPU.aml");
		CaexPreprocessor.removeAdditionalInformation("input/PPU.aml");
		CaexSerializer serializer = new CaexSerializer();
		serializer.writeXMI(xmlFile, resourceSet, "output/ppu_aml.xmi");

		//URI modelURI = URI.createFileURI(new File("testOutput/Topology.xmi").getAbsolutePath());
		//serializer.writeXML(resourceSet.getResource(modelURI, true), "testOutput/Topology_AML_generated.aml");
	}
	
	@org.junit.Test
	public void testReadAml() throws IOException {		
		File xmlFile = new File("input/PPU.aml");
		CaexSerializer serializer = new CaexSerializer();
		serializer.writeXMI(xmlFile, resourceSet, "output/amlfile_Example_Production_system.xmi");
	}

}
