package Test;

import java.io.File;
import java.io.IOException;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceFactoryRegistryImpl;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.junit.Before;

import tools.CaexPreprocessor;
import tools.CaexSerializer;
import CAEX.util.CAEXResourceFactoryImpl;

public class Test {
	
	ResourceSet resourceSet = null;
	
	@Before
	public void setUp() throws Exception {
		resourceSet = new ResourceSetImpl();
		
		ResourceFactoryRegistryImpl.INSTANCE.getExtensionToFactoryMap()
			.put("aml", new CAEXResourceFactoryImpl());
	
		ResourceFactoryRegistryImpl.INSTANCE.getExtensionToFactoryMap()
			.put("xmi", new XMIResourceFactoryImpl());
	}
	
	@org.junit.Test
	public void testReadAml() throws IOException {		
		File xmlFile = new File("input/PPU.aml");
		//CaexPreprocessor.removeAdditionalInformation("input/PPU.aml");
		CaexSerializer serializer = new CaexSerializer();
		serializer.writeXMI(xmlFile, resourceSet, "/output/PPU_AML.xmi");
	}
	
//	@org.junit.Test
//	public void testRoundTrip() throws IOException{
//		File xmlFile = new File("ModbusExample/Role Plant Planner/Plant Topology/Topology.aml");
//		CaexSerializer serializer = new CaexSerializer();
//		serializer.writeXMI(xmlFile, resourceSet, "test/Topology.xmi");
//
//		URI modelURI = URI.createFileURI(new File("test/Topology.xmi").getAbsolutePath());
//		serializer.writeXML(resourceSet.getResource(modelURI, true), "test/Topology_AML_generated.aml");
//	}
//	
//	
//	@org.junit.Test
//	public void testPreprocessor() throws Exception{
//		String filename = "filesystem/amlfile_Example_Production_system.aml";
//		CaexPreprocessor.removeAdditionalInformation(filename);
//	}
	
}
